<template>
  <v-form @submit.prevent="onSubmit">
    <v-container>
      <v-row>
        <v-col
          cols="12"
          md="4"
        >
          <system-language-field
            v-model="$v.form.language.$model"
            :disabled="isLoading"
          />
        </v-col>

        <v-col
          cols="12"
          class="text-right"
        >
          <update-btn
            type="submit"
            :loading="isLoading"
          >
            {{ $t('updateLanguage') }}
          </update-btn>
        </v-col>
      </v-row>
    </v-container>
  </v-form>
</template>

<script>
  import { get } from 'vuex-pathify'
  import { validationMixin } from 'vuelidate'
  import { required } from 'vuelidate/lib/validators'
  import { array } from '@/lib/validators'
  import UpdateBtn from './UpdateBtn'

  const formInitialState = {
    language: '',
  }

  export default {
    name: 'SystemLanguage',
    components: {
      UpdateBtn,
    },
    mixins: [validationMixin],
    data () {
      return {
        isLoading: false,
        form: formInitialState,
      }
    },
    validations: {
      form: {
        language: {
          required,
          array: array(['en-US', 'pt-BR']),
        },
      },
    },
    computed: {
      administrator: get('auth/authUser'),
    },
    created () {
      const { language } = this.administrator
      this.form = { ...this.form, language }
    },
    methods: {
      onSubmit () {
        const form = this.$v.form
        form.$touch()
        if (!form.$anyError) {
          this.isLoading = true
          this.$store.dispatch('auth/updateAuthUserLanguage', { ...this.form })
            .then(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('updateSuccess'),
              })
            })
            .catch(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'error',
                text: this.$t('updateError'),
              })
            })
            .finally(() => {
              this.isLoading = false
            })
        }
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          updateLanguage: 'Alterar idioma',
          updateSuccess: 'Idioma do sistema alterado com sucesso!',
          updateError: 'Ops... Ocorreu um erro ao tentar alterar o idioma do sistema. Por favor, tente novamente.',
        },
        'en-US': {
          updateLanguage: 'Update language',
          updateSuccess: 'System language successfully changed!',
          updateError: 'Oops... An error occurred while trying to change the system language. Please try again.',
        },
      },
    },
  }
</script>
